//this file is part of eMule
//Copyright (C)2002-2005 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#pragma once
#include "ResizableLib\ResizableDialog.h"
#include "SharedFilesCtrl.h"
#include "ProgressCtrlX.h"
// X-Ray :: XP-GroupBox :: Start
/*
#include "IconStatic.h"
*/
#include "Addons/XPGroupBox/XPGroupBox.h"
// X-Ray :: XP-GroupBox :: End
#include "SharedDirsTreeCtrl.h"
#include "SplitterControl.h"
#include "EditDelayed.h" // X-Ray :: ShareFilter

class CSharedFilesWnd : public CResizableDialog
{
	DECLARE_DYNAMIC(CSharedFilesWnd)

public:
	CSharedFilesWnd(CWnd* pParent = NULL);   // standard constructor
	virtual ~CSharedFilesWnd();

	void Localize();
	void ShowSelectedFilesSummary();
	void Reload();
	UINT GetFilterColumn() const	{return m_nFilterColumn;} // X-Ray :: ShareFilter

// Dialog Data
	enum { IDD = IDD_FILES };

	CSharedFilesCtrl sharedfilesctrl;
	CSharedDirsTreeCtrl m_ctlSharedDirTree; // X-Ray :: XPMenus
	CStringArray	m_astrFilter; // X-Ray :: ShareFilter

private:
	CProgressCtrlX pop_bar;
	CProgressCtrlX pop_baraccept;
	CProgressCtrlX pop_bartrans;
	CFont bold;
	// X-Ray :: XP-GroupBox :: Start
	/*
	CIconStatic m_ctrlStatisticsFrm;
	*/
	CXPGroupBox m_ctrlStatisticsFrm;
	// X-Ray :: XP-GroupBox :: End
	// X-Ray :: XPMenus :: Start
	// moved up
	/*
	CSharedDirsTreeCtrl m_ctlSharedDirTree;
	*/
	// X-Ray :: XPMenus :: End
	HICON icon_files;
	CSplitterControl m_wndSplitter;

protected:
	void SetAllIcons();
	void DoResize(int delta);

	// X-Ray :: ShareFilter :: Start
	UINT			m_nFilterColumn;
	CHeaderCtrl		m_ctlSharedListHeader;
	CEditDelayed	m_ctlShareFilter;
	// X-Ray :: ShareFilter :: End

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
	afx_msg void OnBnClickedReloadSharedFiles();
	afx_msg void OnLvnItemActivateSharedFiles(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMClickSharedFiles(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnSysColorChange();
	afx_msg void OnStnDblClickFilesIco();
	afx_msg void OnTvnSelChangedSharedDirsTree(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor); // X-Ray :: XP-GroupBox
	afx_msg LRESULT OnChangeFilter(WPARAM wParam, LPARAM lParam); // X-Ray :: ShareFilter
};
